﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=12.8
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: True
#End Region

Sub Process_Globals
	Private nid As Int = 1
	Private GPS As GPS
	Private Tracking As Boolean
	Private LastUpdateTime As Long
	Private lock As PhoneWakeState
	
	Dim AnnesHouse As Location
	Dim Burns As Location
	Dim Wyott As Location
End Sub

Sub Service_Create
	Service.AutomaticForegroundMode = Service.AUTOMATIC_FOREGROUND_NEVER 'we are handling it ourselves
	GPS.Initialize("gps")
	lock.PartialLock
End Sub

Sub Service_Start (StartingIntent As Intent)
	Service.StartForeground(nid, CreateNotification("..."))
	Track
End Sub

Public Sub Track
	If Tracking Then Return
	If Starter.rp.Check(Starter.rp.PERMISSION_ACCESS_FINE_LOCATION) = False Then
		Log("No permission")
		Return
	End If
	GPS.Start(0, 0)
	Tracking = True
End Sub

Sub GPS_LocationChanged (Location1 As Location)
	If DateTime.Now > LastUpdateTime + 10 * DateTime.TicksPerSecond Then
		Dim n As Notification = CreateNotification($"$2.8{Location1.Latitude} / $2.8{Location1.Longitude}"$)
		n.Notify(nid)
		LastUpdateTime = DateTime.Now
		CheckDistance (Location1)
	End If
	
End Sub

Sub CreateNotification (Body As String) As Notification
	Dim notification As Notification
	notification.Initialize2(notification.IMPORTANCE_LOW)
	notification.Icon = "icon"
	notification.SetInfo("Tracking location", Body, Main)
	Return notification
End Sub

Sub Service_Destroy
	If Tracking Then
		GPS.Stop
	End If
	Tracking = False
	lock.ReleasePartialLock
End Sub

Sub CheckDistance(Location1 As Location)

	Burns.Initialize2(41.19352636486599, -104.3580409042158)
	AnnesHouse.Initialize2(41.166691971869554, -104.76560637064246)
	Wyott.Initialize2(41.11018124285277, -104.83403660434261)
		
	'Log(Location1.DistanceTo(l2))
	ToastMessageShow ("Burns:" & Location1.DistanceTo(Burns), True)
	ToastMessageShow ("Wyott:" & Location1.DistanceTo(Wyott), True)
	ToastMessageShow ("Home:" & Location1.DistanceTo(AnnesHouse), True)
End Sub

